# -*- coding: utf-8 -*-
# Generated by Django 1.10.3 on 2016-12-05 20:23
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('django_openpay', '0007_charge_operation_date'),
    ]

    operations = [
        migrations.CreateModel(
            name='Refund',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('openpay_id', models.CharField(blank=True, max_length=100, verbose_name='OpenPay ID')),
                ('creation_date', models.DateTimeField(blank=True, verbose_name='Creation date')),
                ('authorization', models.CharField(blank=True, max_length=10, null=True, verbose_name='Authorization')),
                ('transaction_type', models.CharField(blank=True, choices=[('charge', 'Charge')], default='charge', max_length=10, verbose_name='Transaction Type')),
                ('operation_type', models.CharField(blank=True, choices=[('in', 'In'), ('out', 'Out')], default='in', max_length=4, verbose_name='Operation Type')),
                ('method', models.CharField(blank=True, choices=[('card', 'Card')], default='card', max_length=10, verbose_name='Method')),
                ('order_id', models.CharField(blank=True, max_length=20, null=True, verbose_name='Order ID')),
                ('status', models.CharField(blank=True, choices=[('completed', 'Completed'), ('in_progress', 'In Progress'), ('failed', 'Failed')], default='in_progress', max_length=14, verbose_name='Status')),
                ('amount', models.DecimalField(decimal_places=2, max_digits=20, verbose_name='Amount')),
                ('description', models.TextField(blank=True, null=True, verbose_name='Description')),
                ('error_message', models.TextField(blank=True, null=True, verbose_name='Error Message')),
                ('currency', models.CharField(blank=True, choices=[('MXN', 'MXN'), ('USD', 'USD')], default='MXN', max_length=8, verbose_name='Currency')),
                ('operation_date', models.DateTimeField(blank=True, null=True, verbose_name='Operation date')),
                ('card', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='django_openpay.Card', verbose_name='Card')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AlterField(
            model_name='charge',
            name='operation_date',
            field=models.DateTimeField(blank=True, null=True, verbose_name='Operation date'),
        ),
        migrations.AddField(
            model_name='refund',
            name='charge',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='refund', to='django_openpay.Charge', verbose_name='Charge'),
        ),
        migrations.AddField(
            model_name='refund',
            name='customer',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='django_openpay.Customer', verbose_name='Customer'),
        ),
    ]
